"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var core_2 = require('@angular/core');
var core_3 = require('@angular/core');
var core_4 = require('@angular/core');
var core_5 = require('@angular/core');
var node_1 = require('./node');
var node_component_1 = require('./node.component');
var DIRECTORY_TREE_TEMPLATE = "\n<div>\n    <ul>\n        <node [node]=\"directory\"\n              (clicked)=\"nodeClicked($event)\">\n        </node>\n    </ul>\n</div>\n";
var DIRECTORY_TREE_STYLE = "\n";
var DirectoryTreeComponent = (function () {
    function DirectoryTreeComponent(_eref) {
        this._eref = _eref;
        this.onChange = new core_2.EventEmitter();
        this.keyboardWatch = false;
    }
    DirectoryTreeComponent.prototype.ngOnInit = function () {
        this.directory = new node_1.Node(this.directory);
        this.currFocusNode = null;
    };
    DirectoryTreeComponent.prototype.nodeClicked = function (nextNode) {
        this.updateFocusNode(nextNode);
        console.log(nextNode);
        this.onChange.emit(nextNode);
    };
    DirectoryTreeComponent.prototype.keydownHandler = function (event) {
        if (!this.keyboardWatch)
            return;
        if (this.currFocusNode === null)
            return;
        switch (event.keyCode) {
            case 13:
                this.onChange.emit(this.currFocusNode);
                break;
            case 37:
                if (this.currFocusNode.isFolder
                    && this.currFocusNode.isExpanded) {
                    this.currFocusNode.isExpanded = false;
                    return;
                }
                if (!this.currFocusNode.hasParent())
                    return;
                this.updateFocusNode(this.currFocusNode.parent);
                break;
            case 38:
                // Move to upper item
                break;
            case 39:
                if (!this.currFocusNode.isFolder)
                    return;
                if (!this.currFocusNode.isExpanded) {
                    this.currFocusNode.isExpanded = true;
                }
                else if (this.currFocusNode.children.length > 0) {
                    this.updateFocusNode(this.currFocusNode.children[0]);
                }
                break;
            case 40:
                if (this.currFocusNode.isFolder
                    && this.currFocusNode.isExpanded
                    && this.currFocusNode.children.length > 0) {
                    // first child
                    this.updateFocusNode(this.currFocusNode.children[0]);
                }
                else {
                }
                break;
        }
    };
    DirectoryTreeComponent.prototype.updateFocusNode = function (next) {
        if (this.currFocusNode)
            this.currFocusNode.blur();
        this.currFocusNode = next;
        this.currFocusNode.focus();
    };
    __decorate([
        core_4.Input(), 
        __metadata('design:type', node_1.Node)
    ], DirectoryTreeComponent.prototype, "directory", void 0);
    __decorate([
        core_4.Input(), 
        __metadata('design:type', Boolean)
    ], DirectoryTreeComponent.prototype, "keyboardWatch", void 0);
    __decorate([
        core_5.Output(), 
        __metadata('design:type', core_2.EventEmitter)
    ], DirectoryTreeComponent.prototype, "onChange", void 0);
    DirectoryTreeComponent = __decorate([
        core_1.Component({
            selector: 'directory-tree',
            template: DIRECTORY_TREE_TEMPLATE,
            directives: [node_component_1.NodeComponent],
            styles: [DIRECTORY_TREE_STYLE],
            host: {
                '(window:keydown)': 'keydownHandler($event)'
            }
        }), 
        __metadata('design:paramtypes', [core_3.ElementRef])
    ], DirectoryTreeComponent);
    return DirectoryTreeComponent;
}());
exports.DirectoryTreeComponent = DirectoryTreeComponent;
//# sourceMappingURL=directory-tree.component.js.map