"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var core_2 = require('@angular/core');
var core_3 = require('@angular/core');
var core_4 = require('@angular/core');
var common_1 = require('@angular/common');
var node_1 = require('./node');
var NODE_COMPONENT_TEMPLATE = "\n<li class=\"all-item\">\n\n    <div *ngIf=\"node.isFolder\">\n        <a (click)=\"clickItem(node)\"\n           class=\"folder-item\"\n           [ngClass]=\"{focus: node._focus}\">\n\n            <span class=\"point\" (click)=\"clickFolderExpand(node)\">\n                <i class=\"fa fa-fw fa-caret-right\" *ngIf=\"!(node.isExpanded)\"></i>\n                <i class=\"fa fa-fw fa-caret-down\" *ngIf=\"node.isExpanded\"></i>\n            </span>\n\n            <i class=\"fa fa-folder-o\" *ngIf=\"!(node.isExpanded)\"></i>\n            <i class=\"fa fa-folder-open-o\" *ngIf=\"node.isExpanded\"></i>\n            {{ node.name }}\n        </a>\n\n        <ul *ngIf=\"node.isExpanded\" class=\"children-items\">\n            <node *ngFor=\"let n of node.children\" [node]=\"n\" (clicked)=\"propagate($event)\"></node>\n        </ul>\n    </div>\n\n    <div *ngIf=\"!node.isFolder\">\n        <a (click)=\"clickItem(node)\"\n           class=\"file-item\"\n           [ngClass]=\"{focus: node._focus}\">\n            <i class=\"fa fa-file-o\"></i>\n            {{ node.name }}\n        </a>\n    </div>\n</li>\n";
var DIRECTORY_TREE_STYLE = "\n.all-item { list-style-type: none }\n.folder-item { }\n.file-item { padding-left: 25px; }\n.children-items {\n  padding-left: 25px;\n  padding-top: 4px;\n  padding-bottom: 4px;\n}\n.focus { color: steelblue }\n";
var NodeComponent = (function () {
    function NodeComponent() {
        this.clicked = new core_4.EventEmitter();
    }
    NodeComponent.prototype.clickFolderExpand = function (node) { this.node.isExpanded = !this.node.isExpanded; };
    NodeComponent.prototype.clickItem = function (node) { this.clicked.emit(node); };
    NodeComponent.prototype.propagate = function (node) { this.clicked.emit(node); };
    __decorate([
        core_2.Input(), 
        __metadata('design:type', node_1.Node)
    ], NodeComponent.prototype, "node", void 0);
    __decorate([
        core_2.Input(), 
        __metadata('design:type', Number)
    ], NodeComponent.prototype, "index", void 0);
    __decorate([
        core_3.Output(), 
        __metadata('design:type', core_4.EventEmitter)
    ], NodeComponent.prototype, "clicked", void 0);
    NodeComponent = __decorate([
        core_1.Component({
            selector: 'node',
            template: NODE_COMPONENT_TEMPLATE,
            directives: [NodeComponent, common_1.NgClass],
            styles: [DIRECTORY_TREE_STYLE]
        }), 
        __metadata('design:paramtypes', [])
    ], NodeComponent);
    return NodeComponent;
}());
exports.NodeComponent = NodeComponent;
//# sourceMappingURL=node.component.js.map